package me.Demon.DemonLevels.data;

import me.Demon.DemonLevels.Main;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.entity.Player;

import java.io.File;
import java.io.IOException;
import java.math.BigInteger;
import java.util.UUID;

public class PlayerData {

    private Player player;
    private UUID uuid;
    private int level;
    private BigInteger exp;
    private BigInteger totalExp;
    private File file;
    private FileConfiguration fileConfiguration;

    public PlayerData(Player player){
        this.player = player;
        this.uuid = player.getUniqueId();
        createPlayerData(); // 若没有这个玩家的数据则会创建一个默认文件
        this.level = fileConfiguration.getInt("level");
        String expString = fileConfiguration.getString("exp");
        this.exp = new BigInteger(expString);
        String totalExpString = fileConfiguration.getString("totalExp");
        this.totalExp = new BigInteger(totalExpString);
    }

    public Player getPlayer() {
        return player;
    }

    public UUID getUuid() {
        return uuid;
    }

    public int getLevel() {
        return level;
    }

    public void setLevel(int level) {
        this.level = level;
    }

    public BigInteger getExp() {
        return exp;
    }

    public void setExp(BigInteger exp) {
        this.exp = exp;
    }

    public BigInteger getTotalExp() {
        return totalExp;
    }

    public void setTotalExp(BigInteger totalExp) {
        this.totalExp = totalExp;
    }

    public void savePlayerData(){
        FileConfiguration yml = this.fileConfiguration;
        yml.set("level",this.level);
        yml.set("exp",this.exp.toString());
        yml.set("totalExp",this.totalExp.toString());
        saveFile();
    }

    public void saveFile(){
        try {
            this.fileConfiguration.save(this.file);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public void createPlayerData(){
        File file = new File(Main.plugin.getDataFolder()+"/PlayerData",uuid.toString()+".yml");
        // 如果文件不存在，则创建新的文件
        if (!file.exists()) {
            try {
                file.getParentFile().mkdirs(); // 创建文件夹
                file.createNewFile(); // 创建文件
            } catch (IOException e) {
                e.printStackTrace();
            }
            // 加载文件配置
            FileConfiguration yml = YamlConfiguration.loadConfiguration(file);
            yml.set("name",player.getName());
            yml.set("uuid",player.getUniqueId().toString());
            yml.set("level",1);
            yml.set("exp",0);
            yml.set("totalExp",1);
            this.file = file;
            this.fileConfiguration = yml;
            saveFile();
            System.out.println("[日志 - 等级] 玩家 "+player.getName()+" 已创建档案数据.");
        }else{
            FileConfiguration yml = YamlConfiguration.loadConfiguration(file);
            this.file = file;
            this.fileConfiguration = yml;
        }
    }
}
