package me.Demon.DemonLevels.manage;

import me.Demon.DemonLevels.Main;
import me.Demon.DemonLevels.util.RandomUtil;
import org.bukkit.configuration.file.FileConfiguration;

public class MobsManage {

    private String mmKey;
    private int minExp;
    private int maxExp;
    private boolean randomModel = false;

    public MobsManage(String mmKey,FileConfiguration yml){
        String expString = yml.getString("MobKillExp."+mmKey);
        if(expString.contains("~")){
            String[] strings = expString.split("~");
            minExp = convertInt(strings[0]);
            maxExp = convertInt(strings[1]);
            randomModel = true;
        }else{
            minExp = convertInt(expString);
            maxExp = convertInt(expString);
        }
        if(Main.Debug){
            System.out.println("[调试 - 输出] MM生物: "+mmKey+"   Min: "+this.minExp+"  Max: "+this.maxExp);
        }
    }

    public String getMmKey() {
        return mmKey;
    }

    public int getExp() {
        if(randomModel){
            return RandomUtil.getRandomInt(this.minExp,this.maxExp);
        }
        return maxExp;
    }

    private int convertInt(String string){
        try {
            return Integer.parseInt(string);
        } catch (NumberFormatException e) {
            return 1;
        }
    }
}
